"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const web3_utils_1 = require("web3-utils");
exports.address = accounting => accounting.contract.address;
exports.sharePrice = (accounting, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    const calculations = yield context.loaders.accountingCalculations(accounting);
    return web3_utils_1.fromWei(calculations.sharePrice.toFixed());
});
exports.grossAssetValue = (accounting, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    const calculations = yield context.loaders.accountingCalculations(accounting);
    return web3_utils_1.fromWei(calculations.gav.toFixed());
});
exports.netAssetValue = (accounting, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    const calculations = yield context.loaders.accountingCalculations(accounting);
    return web3_utils_1.fromWei(calculations.nav.toFixed());
});
exports.holdings = (accounting, _, context) => __awaiter(void 0, void 0, void 0, function* () {
    const holdings = yield accounting.getFundHoldings(context.block);
    return holdings.map(holding => [accounting, holding]);
});
